/***************************************************************************
 *
 * Test program for "STM32F103RBT6".
 * After program start will send 'Hello world!' string to USART1.
 *
 *************************************************************************/
#include "..\LIB\STMF10X\stm32f10x.h"
#include "..\LIB\STMF10X\core_cm3.h"
#include "stm32f10x_conf.h" 

//---------------------------------------------------

//---------------------------------------------------


void Delay(__IO uint32_t nCount);
void RCC_Configuration(void);
void GPIO_Configuration(void);
void USART_Configuration(void);

uint8_t Message1[] = "Hello world!\r\n";

int main(int argc, char *argv[])
{
	RCC_Configuration();
	GPIO_Configuration();
	USART_Configuration();
	int i = 0;
	while (1)
	{
		
		// Wait until end of transmit 
		while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET)
		{
		}
		//USART_SendData(USART1, TxBuffer[10]);
	    if (Message1[i]==0) 
		{
			i=0;
			Delay(100);
		}
		else
		{
			USART_SendData(USART1, Message1[i++]);
		}
	}
	
}

void Delay(__IO uint32_t num)
{
	__IO uint32_t index = 0;

	/* default system clock is 72MHz */
	for(index = (72000 * num); index != 0; index--)
	{
	}
}

void RCC_Configuration(void)
{
	/* Enable GPIO clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);

	/* Enable UART clock */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE); 

}

void GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  
  /* Configure USART Tx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  /* Configure USART Rx as input floating */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

}

void USART_Configuration(void)
{
/* USARTy and USARTz configuration -------------------------------------------*/
  /* USART1 configured as follow:
        - BaudRate = 9600 baud  
        - Word Length = 8 Bits
        - One Stop Bit
        - No parity
        - Hardware flow control disabled (RTS and CTS signals)
        - Receive and transmit enabled

  */
  USART_InitTypeDef USART_InitStructure;
  
  USART_InitStructure.USART_BaudRate = 9600;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

  /* Configure USART1 */
  USART_Init(USART1, &USART_InitStructure);
  
  /* Enable the USART1 */
  USART_Cmd(USART1, ENABLE);

  /* Enable USART1 Half Duplex Mode*/
  //USART_HalfDuplexCmd(USART1, ENABLE);

}



